proc playWinner {} {
  message "YOU WIN!

after [moveCount] moves, [moveCountUndo] undos, and [moveCountRedo] redos" "Winner!"
  saveStatistics 1
  initGame
}

proc playLoser {} {
  message "YOU LOSE!

after [moveCount] moves, [moveCountUndo] undos, and [moveCountRedo] redos" "Loser!"
  saveStatistics 0
  initGame
}

proc winner {} {
  set f [finish]
  if {$f==1} {
    playWinner
  } elseif {$f==-1} {
    playLoser
  }
  return $f
}

proc saveStatistics {won} {
  global GAME

  set f [open g-$GAME(short).txt a]
  puts $f [list [clock seconds] $GAME(start) $won $GAME(seed) [moveCount] [moveCountUndo] [moveCountRedo]]
  close $f
}

proc showStatistics {} {
  global GAME

  if {![catch {set f [open g-$GAME(short).txt r]}]} {
	  set stat {}
	  while {![eof $f]} {
	    set l [gets $f]
	    if {$l!=""} {lappend stat $l}
	  }
	  close $f
	
	  set stat [lsort $stat]
	
	  # calc won, lost games, length of streaks
	  set w 0
	  set l 0
	  set ws 0; set lws 0
	  set ls 0; set lls 0
	  set g [llength $stat]
	  foreach s $stat {
	    if {[lindex $s 2]==1} {
	      incr ws
	      incr w
	      set lls [max $lls $ls]
	      set ls 0
	    } else {
	      incr ls
	      incr l
	      set lws [max $lws $ws]
	      set ws 0
	    }
	  }
	  set lls [max $lls $ls]
	  set lws [max $lws $ws]
	
	  message "$g total Games played
$w won ([expr 100*$w/$g]%)
$l lost ([expr 100*$l/$g]%)

Longest winning streak: $lws
Longest losing streak: $lls" Statistics
  } else {
	  message "No games played yet!" Statistics
  }
}

proc readOLD {} {
  global GAME OLD OLDstate

  catch {array unset OLD}

  set OLD {}
  if {![catch {set f [open g-$GAME(short).txt r]}]} {
    while {![eof $f]} {
      set l [gets $f]
      if {$l!=""} {
        set real [expr [lindex $l 4]-[lindex $l 5]+[lindex $l 6]]
        lappend OLD [concat [list [enuDate [lindex $l 0]] [enuDate [lindex $l 1]]] [lrange $l 2 6] $real]
      }
    }
    close $f
  }

  set OLDstate -1
  sortOLD 0
}

proc sortOLD {ix} {
  global OLD widget OLDstate gameCount sortingOrder

  if {$sortingOrder==1} {
	  if {$ix>=0} {
	    if {$ix>1} {
	      set OLD [lsort -index $ix -integer $OLD]
	    } else {
	      set OLD [lsort -index $ix $OLD]
	    }
	  }
  } else {
	  if {$ix>=0} {
	    if {$ix>1} {
	      set OLD [lsort -index $ix -integer -decreasing $OLD]
	    } else {
	      set OLD [lsort -index $ix -decreasing $OLD]
	    }
	  }
  }
  $widget(old) delete 0 end
  set gameCount 0
  set fmt "%s..%s %3d (%5d) %3d(%3d/%3d) %4d"
  foreach e $OLD {
    if {$OLDstate==-1 || [lindex $e 2]==$OLDstate} {
      $widget(old) insert end [listFormat $fmt $e]
      incr gameCount
    }
  }
}
