source menu.tcl
source bind.tcl
source cards.tcl
source stacks.tcl
source math.tcl
source move.tcl
source util.tcl
source game.tcl

#---------------------------------------------------------------- Splash Screen
proc splash {{ms 0}} {
    global GAME
    update idletasks
    if {[file readable pics/splash.gif]} {
	    if {[winfo exists .x]} return
	    toplevel .x -bd 3 -relief raised
	    wm withdraw .x
	    set sw [winfo screenwidth .]
	    set sh [winfo screenheight .]
	        image create photo "title" \
	          -file pics/splash.gif
	    wm overrideredirect .x 1
	    label .x.l -image title -bd 1 -relief sunken
	    label .x.t -relief flat -text $GAME(name) -relief sunken -font {Helvetica 12 bold}
	    pack .x.t -side top -expand 0 -fill x
	    pack .x.l -side top -expand 1 -fill both
	    set x [expr {($sw - [image width title])/2}]
	    set y [expr {($sh - [image height title])/2}]
	    wm geometry .x +$x+$y
	    wm deiconify .x
	    raise .x
	    update idletasks
	    if {$ms>0} {
	      after $ms {catch {destroy .x}}
	    } else {
	      grab .x
	      tkwait window .x
	    }
    }
}

Window hide $widget(winold)
Window hide $widget(topwindow)

wm title $widget(topwindow) $GAME(name)

for {set i 0} {$i<$DATA(STACKS)} {incr i} {
  stackNew $i $widget(area) $DATA($i,x) $DATA($i,y) $DATA($i,xo) $DATA($i,yo)
}

Window show $widget(topwindow)
Window hide $widget(rulesWindow)
splash 2500
initGame
